
	// Trackbal code by Claudio Rocchini

class CTrackBall
{
public:
	inline CTrackBall( void ) { m_bSpinning = FALSE; }
	inline ~CTrackBall( void ) { }
	void Init( GLint width, GLint height );
	void Resize( GLint width, GLint height );
	void MouseDown( int glMouseDownX, int glMouseDownY, int nButton );
	void MouseUp( int posx, int posy );
	void CalcRotMatrix( GLfloat matRot[4][4], int posx, int posy );
	void CalcScaVector( GLfloat vecSca[3], int posx, int posy );
	void CalcTraVector( GLfloat vecTra[3], int posx, int posy );
	void CalcRotMatrix( GLfloat matRot[4][4] );		// Per spin
	BOOL IsSpin( void ) const { return m_bSpinning; }
	void SetSpin( BOOL bS ) { m_bSpinning = bS; }

	inline float * GetCurQuat() { return m_curquat; }
	inline float * GetLastQuat() { return m_lastquat; }

private:
    GLint	m_giWidth;
    GLint	m_giHeight;
	float   m_curquat[4];
	float   m_lastquat[4];
	int		m_glMouseDownX;
	int		m_glMouseDownY;
	BOOL	m_bSpinning;

	void CalcQuat(float q[4], float p1x, float p1y, float p2x, float p2y);
	void AxisToQuat(float a[3], float phi, float q[4]);
	void AddQuats(float q1[4], float q2[4], float dest[4]);
	void BuildRotmatrix(float m[4][4], float q[4]);
};
