// glwrapperView.h : interface of the CGlwrapperView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLWRAPPERVIEW_H__8D770B8E_17E0_11D5_9E25_0080C88B30AF__INCLUDED_)
#define AFX_GLWRAPPERVIEW_H__8D770B8E_17E0_11D5_9E25_0080C88B30AF__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <GL\\gl.h>
#include <GL\\glu.h>


#include "Trackball.h"


class CGlwrapperView : public CView
{
protected: // create from serialization only
	CGlwrapperView();
	DECLARE_DYNCREATE(CGlwrapperView)

// Attributes
public:
	CGlwrapperDoc* GetDocument();

	CPalette    m_cPalette;				// Palette Personale
    CPalette    *m_pOldPalette;			// Vecchia Palette
	CClientDC	*m_pDC;					// DC della finestra
	HGLRC		m_hrc;					// Contesto OpenGL

	static CGlwrapperView * m_glOwner;	// IL proprietario del contesto GL

	inline BOOL SetGL()
	{
		if(m_glOwner!=this)
		{
			if(!wglMakeCurrent(m_pDC->GetSafeHdc(), m_hrc))
			{
				AfxMessageBox("GlMakeCurrent Error");
				return FALSE;
			}
			m_glOwner = this;
		}
		return TRUE;
	}

	CTrackBall  m_TrackBall;
	BOOL		m_bCaptured;			// Drag in corso
	int         m_nMode;				// Tipo di drag: 0=rot 1=sca
	GLfloat		m_utrans[3];			// Traslazione utente
	GLfloat		m_matRot[4][4];			// Matrice di rotazione utente

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGlwrapperView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGlwrapperView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGlwrapperView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in glwrapperView.cpp
inline CGlwrapperDoc* CGlwrapperView::GetDocument()
   { return (CGlwrapperDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLWRAPPERVIEW_H__8D770B8E_17E0_11D5_9E25_0080C88B30AF__INCLUDED_)
